// 
// config.hh     : Common defines + other config parameters
// authors       : Chalermek Intanagonwiwat and Fabio Silva
//
// Copyright (C) 2000-2001 by the Unversity of Southern California
// $Id: config.hh,v 1.22 2001/06/14 23:52:24 fabio Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

// Software information
#define PROGRAM "Diffusion 3.0.3"
#define RELEASE "Beta 1"
#define DEFAULT_CONFIG_FILE "config.txt"

// Timers
#define INTEREST_TIMER         1
#define ENERGY_TIMER           2
#define GRADIENT_TIMER         3
#define SUBSCRIPTION_TIMER     4
#define NEIGHBORS_TIMER        5
#define FILTER_TIMER           6
#define FILTER_KEEPALIVE_TIMER 7
#define APPLICATION_TIMER      8
#define REINFORCEMENT_TIMER    9
#define DATA_FORWARD_TIMER     10
#define STOP_TIMER             11
#define PACKET_RECEIVED        12

// Configurable parameters start here

// DELAYS are used in placing event on the event queue
#define INTEREST_FORWARD_DELAY   2000        // (msec) bw receive and forward
#define INTEREST_FORWARD_JITTER  1500        // (msec) jitter
#define INTEREST_DELAY          20000        // (msec) bw sends
#define INTEREST_JITTER          5000        // (msec) jitter
#define GRADIENT_DELAY          15000        // (msec)  
#define SUBSCRIPTION_DELAY      10000        // (msec) bw checks
#define NEIGHBORS_DELAY         10000        // (msec) bw checks
#define FILTER_DELAY            60000        // (msec) bw checks
#define FILTER_KEEPALIVE_DELAY  20000        // (msec) bw sends
#define REINFORCEMENT_DELAY     15000        // (msec) bw checks
#define DATA_FORWARD_DELAY        300        // (msec) bw receive and forward
#define DATA_FORWARD_JITTER       200        // (msec) jitter

// TIMEOUTS are used when comparing with current time
#define SUBSCRIPTION_TIMEOUT    60           // seconds
#define GRADIENT_TIMEOUT       120           // seconds
#define NEIGHBORS_TIMEOUT       90           // seconds
#define FILTER_TIMEOUT          40           // seconds
#define DISCOVER_MESSAGE_PERIOD 60           // seconds

// Number of packets to keep in the hash table

#define HASH_TABLE_MAX_SIZE           1000
#define HASH_TABLE_REMOVE_AT_ONCE       20
#define HASH_TABLE_DATA_MAX_SIZE       100
#define HASH_TABLE_DATA_REMOVE_AT_ONCE  10
